//
// VMime library (http://www.vmime.org)
// Copyright (C) 2002 Vincent Richard <vincent@vmime.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Linking this library statically or dynamically with other modules is making
// a combined work based on this library.  Thus, the terms and conditions of
// the GNU General Public License cover the whole combination.
//

/* modified from defaultTimeoutHandler.cpp */

#include "vmime/config.hpp"
#include "timeout_handler.hpp"


parameterized_timeout_handler::parameterized_timeout_handler
(int timeout_seconds)
{

	m_startTime = time(NULL);
	this->timeout_seconds = timeout_seconds;
}


parameterized_timeout_handler::~parameterized_timeout_handler()
{

}


bool parameterized_timeout_handler::isTimeOut()
{

	return time(NULL) - m_startTime >= timeout_seconds;
}


void parameterized_timeout_handler::resetTimeOut()
{

	m_startTime = time(NULL);
}


bool parameterized_timeout_handler::handleTimeOut()
{

	return false;
}

parameterized_timeout_handler_factory::parameterized_timeout_handler_factory
(int timeout_seconds)
{
	this->timeout_seconds = timeout_seconds;
}

parameterized_timeout_handler_factory::~parameterized_timeout_handler_factory()
{
}

vmime::shared_ptr <vmime::net::timeoutHandler>
parameterized_timeout_handler_factory::create()
{
//	vmime::shared_ptr <vmime::net::timeoutHandler> handler =
	return vmime::make_shared <parameterized_timeout_handler>(timeout_seconds);
//	handler.set_timeout()
}
