#!/bin/sh

rm -rf build/
mkdir build/

# perhaps we'll also disable VMIME_HAVE_FILESYSTEM_FEATURES ?
## perhaps we should change CMAKE_BUILD_TYPE to Release or MinSizeRel.
cmake \
    -D GNU_HOST=i686-w64-mingw32 \
    -D CMAKE_TOOLCHAIN_FILE=./mingw_cross_toolchain.cmake \
    -D OPENSSL_ROOT_DIR=../openssl-1.1.0h/ \
    -D VMIME_TLS_SUPPORT_LIB=openssl \
    -D VMIME_HAVE_SASL_SUPPORT=OFF \
    -D VMIME_BUILD_DOCUMENTATION=OFF \
    -D VMIME_HAVE_MESSAGING_PROTO_SENDMAIL=OFF \
    -D VMIME_HAVE_MESSAGING_PROTO_MAILDIR=OFF \
    -D CMAKE_BUILD_TYPE=MinSizeRel. \
    -B build/ ./

cd build/ && make vmime-static
cd ../
cp build/build/lib/libvmime.a .
cp build/src/vmime/config.hpp src/vmime/
